
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.*;
import java.io.*;
import javax.swing.*;

/**
 * <strong>Tarea 3.</strong><br>
 * Tarea 3 de la asigantura ELO-329.
 * Diseno y Programacion Orientados a Objetos.
 * Profesor: Agustin Gonzalez V.
 * <br>
 * <h4>Descripci&oacute;n:</h4>
 * <p>La tarea tiene como objetivo mejorar una tarea de un a&ntilde;o anterior.
 * Se tiene un applet que consiste en una imagen hecha puzzle. La idea es
 * mejorar dicho applet agreg&aacute;ndole un gr&aacute;fico que muestre la
 * cantidad de piezas correctamente ubicadas versus el numero de moviemientos
 * hechos. Adem&aacute;s se intenta corregir la forma en que se crea el
 * puzzle.</p>
 * <h4>Problemas enfrentados:</h4>
 * <p>Un obst&aacute;culo en la realizaci&oacute;n de la tarea fue implementar
 * un gr&aacute;fico din&aacute;mico. Se trat&oacute; de adaptar el
 * c&oacute;digo del gr&aacute;fico que se encuentra en la p&aacute;gina web del
 * ramo. La idea era utilizar un lista enlazada, para poder ir agregando nuevos
 * datos sin mayor problema. Sin embargo llegu&eacute; a un punto en que se
 * deb&iacute;a modificar demasiado el c&oacute;digo, por eso opt&eacute; por
 * dejar el gr&aacute;fico limitado a los &uacute;ltimos 10 valores. </p>
 * <p>Otro inconveniente fue el de crear una estructura para poder mostrar el
 * gr&aacute;fico y el puzzle. De entre todas las posibilidades que ofrece JAVA
 * me decid&iacute; por hacer un SplitPanel, por su simplicidad. Aprovechando
 * las capacidades de este panel, se implement&oacute; un m&eacute;todo para
 * escalar la imagen del puzzle para hacerla calzar en el applet, en caso que
 * &eacute;sta fuese demasiado grande. Adem&aacute;s, aprovechando la capacidad
 * de escalar im&aacute;genes, agregu&eacute; a la tarea una imagen miniatura 
 * de como debiese ser el puzzle, para que el usuario tenga una referencia y no 
 * se le complique el armado. </p>
 * <p>Cabe mencionar que como el c&oacute;digo del gr&aacute;fico no es idea
 * m&iacute;a, sino que fue tomado desde la p&aacute;gina web del ramo,
 * decid&iacute; no modificarlo demasiado. Es por esto que al realizar el 
 * chequeo de estilo, &eacute;ste informa que hay un m&eacute;todo en el 
 * archivo ChartPanel.java que excede las 40 l&iacute;neas.</p>
 * @version 1.0 | 30-05-2005
 * @author Eduardo Gonzalez Fisher.
 */
public class Tarea3 extends JApplet
{
  /** Imagen del puzzle */
  private Image imagen;
  /** Imagen en miniatura */
  private Image solucion;
  /** Splitpanel 1 (horizontal) */
  private JSplitPane splitPane = null;
  /** Splitpanel 2 (vertical) */
  private JSplitPane splitPane2 = null;
  /** Numero de divisiones verticales */
  private int vertical;
  /** Numero de divisiones horizontales */
  private int horizontal;

    /**
     * Inicia el Applet
     */
  public void init ()
  {
    final int NUM_DATOS = 10;
    final int DIV_MIN = 100;
    final int DIV_MEDIO = 600;
    double[] v = new double[NUM_DATOS];
      String[] n = new String[NUM_DATOS];
    for (int i = 0; i < NUM_DATOS; i++)
      {
        v[i] = 0;
        n[i] = " ";
      }
    obtenerParametros ();
    solucion = cambiarDimensiones (imagen, true);
    JLabel thumb = new JLabel (new ImageIcon (solucion));
    ChartPanel grafo = new ChartPanel (v, n, vertical * horizontal);
    imagen = cambiarDimensiones (imagen, false);
    Puzzle puz = new Puzzle (imagen, grafo, horizontal, vertical);
    splitPane2 = new JSplitPane (JSplitPane.VERTICAL_SPLIT, grafo, thumb);
    splitPane = new JSplitPane (JSplitPane.HORIZONTAL_SPLIT, puz, splitPane2);
    splitPane.setContinuousLayout (false);
    splitPane.setOneTouchExpandable (false);
    splitPane.setDividerLocation (DIV_MEDIO);
    splitPane2.setContinuousLayout (true);
    splitPane2.setOneTouchExpandable (false);
    splitPane2.setDividerLocation (DIV_MIN + DIV_MIN);
    grafo.setMinimumSize (new Dimension (solucion.getWidth (null), DIV_MIN));
    thumb.setMinimumSize (new Dimension (solucion.getWidth (null),
                                         solucion.getHeight (null)));
    puz.setMinimumSize (new Dimension (imagen.getWidth (null), DIV_MEDIO));
    resize (DIV_MIN + imagen.getWidth (null) + solucion.getWidth (null),
            imagen.getHeight (null) + DIV_MIN);
    Container contentPane = getContentPane ();
    contentPane.add (splitPane);
  }
  /**
   * Cambia la resolucion de la imagen.
   * Con el proposito de ajustarla al Applet.
   * @param t Imagen a escalar.
   * @param thumb indica si se escala como miniatura o no
   * @return La imagen escalada.
   */
  private Image cambiarDimensiones (Image t, boolean thumb)
  {
    final int PUZZLE_ANCHO = 500;
    final int PUZZLE_ALTO = 400;
    final int MINI_ALTO = 200;
    final int MINI_ANCHO = 200;
    final int AUTO_RESIZE = -1;
    if (thumb)
      {
        if (t.getHeight (null) > t.getWidth (null))
          return t.getScaledInstance (-1, MINI_ALTO, Image.SCALE_FAST);
        else
          return t.getScaledInstance (MINI_ANCHO, -1, Image.SCALE_FAST);
      }
    else
      {
        if (t.getHeight (null) > t.getWidth (null)
            * PUZZLE_ANCHO / PUZZLE_ALTO)
          return t.getScaledInstance (-1, PUZZLE_ALTO, Image.SCALE_FAST);
        else
          return t.getScaledInstance (PUZZLE_ANCHO, -1, Image.SCALE_FAST);
      }
  }

  /**
   * Lee los parametros del applet.
   */
  private void obtenerParametros ()
  {
    imagen = getImage (getDocumentBase (), getParameter ("img"));
    vertical = Integer.parseInt (getParameter ("v"));
    horizontal = Integer.parseInt (getParameter ("h"));
  }
}


